#include <stdio.h>

#define SIZE 10

int main() {
    int x;
    int a[SIZE];
    int i, sum;

	/* Initialisierung von a */
    for (i = 0; i < SIZE; i++)
	a[i] = i * i;

	/* Elemente von a aufsummieren */
    for (i = 0, sum = 0; i < SIZE; i++)
	sum += a[i];
    printf("Summe: %d\n", sum);

	/* typischer Fehler: ein Element zuviel */
    for (i = 0, sum = 0; i <= SIZE; i++)
	sum += a[i];
    printf("Summe: %d\n", sum);

	/* VORSICHT - Lebensgefahr! */
    x = i = 0;
    printf("x=%d, i=%d\n", x, i);
    a[SIZE]++;
    printf("x=%d, i=%d\n", x, i);

    a[SIZE+10000]++;	/* => segmentation fault */

    return 0;
}
