#include <stdio.h>

int main() {
    char ch = 5;
    unsigned short s;
    int i = 71124;

	/* Nur die hinteren (niederwertigsten) 4 Bytes
	 * von i werden s zugewiesen, da nicht mehr Platz ist!
	 * (Dies entspricht dem Rest der Division i / 2^16,
	 *  wobei 2^16 = 65536.) */
    s = i;
    printf("s=%08xh, i=%08xh\n", s, i);
    printf("s=%08hx, i=%08hx\n", s, i);
    printf("s=%08x, i=%08x\n", s, i);
    printf("s=%d, i=%d\n", s, i);

	/* ch und s werden nach int konvertiert! */
    i = ch + s + 8;
    printf("i=%d, ch=%d, s=%d\n", i, ch, s);

	/* 882 passt nicht in eine char
	 * => nur die niederwertigsten 8 Bit werden zugewiesen! */
    ch = 882;
    printf("ch='%c', ch=%02xh, 882=%02xh\n", ch, ch, 882);
    printf("ch='%c', ch=%02hx, 882=%02hx\n", ch, ch, 882);

    return 0;
}
